package dev.shadowsoffire.apotheosis.adventure.affix.augmenting;

import dev.shadowsoffire.placebo.network.MessageHelper;
import net.minecraftforge.network.NetworkEvent;
import java.util.function.Supplier;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixRegistry;
import net.minecraft.network.FriendlyByteBuf;
import dev.shadowsoffire.placebo.network.MessageProvider;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.placebo.reload.DynamicHolder;

record RerollResultMessage(DynamicHolder<? extends Affix> newAffix) {
    public static class Provider implements MessageProvider<RerollResultMessage>
    {
        public Class<?> getMsgClass() {
            return RerollResultMessage.class;
        }
        
        public void write(final RerollResultMessage msg, final FriendlyByteBuf buf) {
            buf.m_130085_(msg.newAffix.getId());
        }
        
        public RerollResultMessage read(final FriendlyByteBuf buf) {
            return new RerollResultMessage((DynamicHolder<? extends Affix>)AffixRegistry.INSTANCE.holder(buf.m_130281_()));
        }
        
        public void handle(final RerollResultMessage msg, final Supplier<NetworkEvent.Context> ctx) {
            MessageHelper.handlePacket(() -> AugmentingScreen.handleRerollResult(msg.newAffix()), (Supplier)ctx);
        }
    }
}
